# Rules for breaching SLOs, currently these are only applied to severity::{1,2} corrective action issues
# https://about.gitlab.com/handbook/engineering/quality/issue-triage/#severity-slos
resource_rules:
  issues:
    rules:
      - name: Add due date to all high severity corrective actions based on SLO
        conditions:
          labels:
            - "incident-review"
          ruby: |
            slo_update_due_date_incident_review?
          state: opened
        actions:
          comment: |
            Setting a due date of #{slo_breach_date_incident_review} based on the [process for asynchronous reviews](https://handbook.gitlab.com/handbook/engineering/infrastructure/incident-review/#process-for-asynchronous-reviews)
            /due #{slo_breach_date_incident_review}


            #{footer_platform("slo-on-incident-review")}

      - name: Warn of impending SLO breaches for incident reviews
        conditions:
          state: opened
          labels:
            - "incident-review"
          forbidden_labels:
            - SLO::Missed
            - SLO::Near Miss
          ruby: |
            slo_breach_looming_incident_review?
        actions:
          labels:
            - SLO::Near Miss
          comment: |
            :wave: #{mentions_for_slo} @kkyrala

            This ~"incident-review" is halfway through the amount of time we allocate based on the [process for asynchronous reviews](https://handbook.gitlab.com/handbook/engineering/infrastructure/incident-review/#process-for-asynchronous-reviews)

            #{footer_platform("slo-on-incident-review")}
      - name: Add missed slo label to corrective actions over SLO threshold
        conditions:
          state: opened
          labels:
            - "incident-review"
          forbidden_labels:
            - SLO::Missed
          ruby: |
            slo_breached_incident_review?
        actions:
          labels:
            - SLO::Missed
          comment: |
            :wave: #{mentions_for_slo} @kkyrala

            This ~"incident-review" is taking longer than our target completion time based on the [process for asynchronous reviews](https://handbook.gitlab.com/handbook/engineering/infrastructure/incident-review/#process-for-asynchronous-reviews)

            #{footer_platform("slo-on-incident-review")}
